#!/usr/bin/perl

$LoginNotRequired = 1;
require "event/login.pl";

require "gr/datetime.pl";

require "vars.pl";

if ($c{sid} ne ""){
  %r = &DataGetSessionRec($c{sid});
}

%radio = getRadio();

chdir "event";

use event::Tourn;

CgiPrintHeader();

############################
# Set this to the event id; such as 2010wc
############################
#$in{e} = "test6";
#$in{e} = "2010ac";
$in{e} = $eventId; # setup in the vars.pl file

$e = ProcessInputChange($in{e}, 'lower', 'alphaNum');

if ($e eq ''){
  HtmlErrorPage("Need Event", "The event id was not given.");
  exit;
}

if (! Tourn->exists($e)){
  HtmlErrorPage("Need Event", "The event [$e] was not found.");
  exit;
}

$ev = Tourn->load($e);
if (! $ev){
  HtmlErrorPage("Not Read", "Event [$e] could not be read.\n");
  exit;
}

$now = time;

%e = $ev->getEvent();
@games = $ev->getGames();
$round = $ev->getRound();
$status = $ev->getRoundStatus($round);
$eventName = $ev->getEventFullName();

$gmt = "GMT";
if ($r{id} ne ""){ $gmt = "YLT"; }

for($rn=1; $rn<=$round; $rn++){
#for($rn=$round; $rn>=1; $rn--){
  @g = $ev->getGamesByRound($rn);
  $gameRows = '';
  @gameRows = ();
  foreach $g (@g){
    ($w, $b, $ts, $tc, $why, $ply, $gid, $tgid) = ($g->{1}, $g->{2}, $g->{schts}, $g->{timecontrol}, $g->{why}, $g->{move}, $g->{gid}, $g->{tgid});

# If the scheduled time of the game has passed and we don't have the result, check the games table for it
    if (($ts>0) && ($ts<$now) && ($why eq '') && ($tgid)){
      %gr = &DataGetPastGameRec("tempid=$tgid limit 1");
      if ($gr{id} ne ''){
        $g->{1} = $gr{wusername};
        $g->{2} = $gr{busername};
        $g->{timecontrol} = $gr{timecontrol};
        $g->{why} = $gr{termination};
        $g->{move} = $gr{plycount};
        $g->{gid} = $g{id};
        if ($gr{result} eq 'w'){ $g->{won} = '1'; }
        if ($gr{result} eq 'b'){ $g->{won} = '2'; }
        if ($gr{result} eq 'd'){ $g->{won} = 'd'; }
        ($w, $b, $ts, $tc, $why, $ply, $gid, $tgid) = ($g->{1}, $g->{2}, $g->{schts}, $g->{timecontrol}, $g->{why}, $g->{move}, $g->{gid}, $g->{tgid});
      }
    }

    $wwin = ''; $bwin = '';
    if ($g->{won} eq '1'){ $wwin = '*'; }
    if ($g->{won} eq '2'){ $bwin = '*'; }
    if ($g->{won} eq 'd'){ $wwin = '='; $bwin = '='; }

    if ($tc eq ''){
      $tc = $ev->getRoundTimecontrol($rn);
    }
    $tc = qq(<a href="/arimaa/gameroom/timecontrol.cgi?tc=$tc" target=_blank>$tc</a>);

#    $scheduled = ($ts>0) ? &getDayHrMin($ts - $r{timezone}) : '';
#    $scheduled = ($ts>0) ? &getWhen($ts - $r{timezone}) : '';
    if ($ts>0){
      if (($useTZ) && ($r{timezone} ne '')){
        $scheduled = getDayHrMin($ts - $r{timezone});
      }
      else{
        $stsCount += 1;
        $scheduled = "<span id='sts$stsCount' style='display:none'>$ts</span><span id='stm$stsCount'></span>";
      }
    }
    $scheduled = ($ply ne "") ? "<a href='javascript:openComm($gid)' title='game comments'>$why $ply</a>" : $scheduled;

#    $scheduled = ($ply ne "") ? "<a href='javascript:comPage($gid)'>$why $ply</a>" : $scheduled;

    $gameTimes = '';
    if ($g->{won} ne ''){ $clickOnBoard = 1; }
    else{
      if ($ts>0){ $gameTimes = 1; }
    }

    $players = lc("$w $b");
    $radio = '';
    if (($radio{$players} ne '') && ($now - $ts < 3600)){
      $radio = "<font color=red title='Live commentary during game'>*</font>";
    }


    $board = <<EOM;
<table background="/arimaa/graphics/BoardWithPiecesIcon.jpg" width=50 height=50 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td >
<a href="javascript:openGame('$gid','v','w', $tgid);" title='view game'>
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
    <td >
<a href="javascript:openGame('$gid','v','b', $tgid);" title='view game'>
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
  </tr>
</table>
EOM

    if ($w eq $b){ 
      $gameRow = <<EOM;
<tr>
  <td align=right>
    <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>bye
  </td>
</tr>
EOM
      $gameRows .= $gameRow;
      push(@gameRows, "$ts $gameRow");
      next;
    }
    $gameRow = <<EOM;
<tr>
  <td align=right>
    <nobr>$wwin <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font></nobr>
  </td>
  <td align=center>
    <font size=1>$scheduled $radio</font>$board
  </td>
  <td align=left>
    <nobr><a href="javascript:playerPage('$b')">$b</a> $bwin<br><font size=-1>$br</font></nobr>
  </td>
</tr>
EOM
    $gameRows .= $gameRow;
    if ($ts eq ''){ $ts = '99999999999'; } # this is so that unschedled games are last
    push(@gameRows, "$ts $gameRow");

  }

  @gameRows = sort(@gameRows);
  foreach (@gameRows){
    $_ =~ s/^\d+ //;
  }
  $gameRows = join("\n", @gameRows);

  if ($clickOnBoard){
    $clickOnBoard = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<b>
<font size=-2>
Click board<br>to view game
</font>
</b>
    </td>
  </tr>
EOM
  }

  $roundName = "Round $rn";

  if ($gameTimes){
    $clickOnBoard = '';
    $gameTimes = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<b>
<font size=-2>
Click board to watch live game
<br>
<font color=red>*</font> = Live commentary
</font>
</b>
    </td>
  </tr>
EOM
  }

  $watchGames .= <<EOM;
<td valign=top>
<table border=0>
  <tr><td></td>
    <td colspan=2 align=left>
<b>
$roundName
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $gameTimes
  $clickOnBoard
  $gameRows
</table>
<td>
EOM

  $func = <<EOM;
    <script language="JavaScript1.2">
<!--
function playerPage(u){
    open('/arimaa/gameroom/playerpage.cgi?u='+u,'','toolbar=no,width=650,height=450,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function comPage(g){
    open('/arimaa/gameroom/comments.cgi?gid='+g,'','');
    void('');
}

function reasonCodes(){
  open('/arimaa/gameroom/reasonCodes.html','','toolbar=no,width=650,height=450,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
}

function openComm(id){
  open('/arimaa/gameroom/comments.cgi?gid='+id,'','');
}

function openGame(id, role, side, tgid){
  if (parseInt(id) > 0){
//    open('/arimaa/games/showGame.cgi?gid='+id+'&s='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
//    open('/arimaa/gameroom/comments.cgi?gid='+id,'','');
    open('/arimaa/gameroom/opengamewin.cgi?client=1&role=v&side=w&gameid='+id,'','');
  }
  else{
    if (parseInt(id) == 0){
      alert("Game was won by forfeit");
    }
    else{
//      alert("To watch the game login to the Arimaa gameroom at the scheduled time and look under 'Live Games'");
      open('/arimaa/gameroom/opengamewin.cgi?client=1&role=v&side=w&gameid='+tgid,'','');
    }
  }
  void('');
}

function showTimes(){
  var s, s2, id, id2, tzo, ts, w;
  tzo = document.getElementById('tzo').value;
//alert('in show');
  if (tzo == ''){
    setTimeout('setTimeZone()', 10);
//tzo = document.getElementById('tzo').value;
//alert(tzo);
    return;
  }
  tzo = 3600*tzo;
  for(i=1; i<10; i++){
    id = 'sts'+i;
    id2 = 'stm'+i;
    s = document.getElementById(id);
    s2 = document.getElementById(id2);
//alert('x');
//    if (s == null){ break; }
    if (s == null){ continue; }
//alert('y');
    ts = parseInt(s.innerHTML);
    w = getWhen(ts + tzo);
    s2.innerHTML = w;
  }
}

function getWhen(t){
  var res;
  var d = new Date();
  var now = d.getTime();
  now = now/1000;
//  now = glob.resp.time;

  if (Math.abs(now-t) < 6*86400){
    res = getDayHrMin(t);
  }
  else{
    if (Math.abs(now-t) < 90*86400){
      res = getMonDateTime(t);
    }
    else{
      res = getMonDateYearTime(t);
    }
  }
  return res;
}

function getDayHrMin(t){
  var res;
  var d = new Date(t*1000);
  var hours=d.getUTCHours()
  var minutes=d.getUTCMinutes()
  var day=d.getUTCDay()
  var month=d.getUTCMonth()
  var date=d.getUTCDate()
  var dayNameStr="Sun Mon Tue Wed Thr Fri Sat";
  var dayName=dayNameStr.split(" ");
  var monNameStr = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec";
  var monName=monNameStr.split(" ");
  var ck, c, dn;

  day = dayName[day];
  month = monName[month];

//  ck = 'time24'+glob.id;
//  c = getCookie(ck);
  dn = ""
  if ((c == undefined) || (parseInt(c) < 1)){
    dn="am"
    if (hours>11){ dn="pm" }
    if (hours>12){ hours=hours-12; }
    if (hours==0){ hours=12; }
  }

  if (minutes<=9)
  minutes="0"+minutes
  res = day+" "+hours+":"+minutes+" "+dn;
  return res;
}

function getMonDateTime(t){
  var res;
  var d = new Date(t*1000);
  var hours=d.getUTCHours()
  var minutes=d.getUTCMinutes()
  var day=d.getUTCDay()
  var month=d.getUTCMonth()
  var date=d.getUTCDate()
  var dayNameStr="Sun Mon Tue Wed Thr Fri Sat";
  var dayName=dayNameStr.split(" ");
  var monNameStr = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec";
  var monName=monNameStr.split(" ");
  var ck, c, dn;

  day = dayName[day];
  month = monName[month];

//  ck = 'time24'+glob.id;
//  c = getCookie(ck);
  dn = ""
  if ((c == undefined) || (parseInt(c) < 1)){
    dn="am"
    if (hours>11){ dn="pm" }
    if (hours>12){ hours=hours-12; }
    if (hours==0){ hours=12; }
  }

  if (minutes<=9)
  minutes="0"+minutes
  res = month+' '+date+' '+hours+":"+minutes+" "+dn;
  return res;
}

function getMonDateYearTime(t){
  var res;
  var d = new Date(t*1000);
  var hours=d.getUTCHours()
  var minutes=d.getUTCMinutes()
  var year=d.getUTCFullYear()
  var day=d.getUTCDay()
  var month=d.getUTCMonth()
  var date=d.getUTCDate()
  var dayNameStr="Sun Mon Tue Wed Thr Fri Sat";
  var dayName=dayNameStr.split(" ");
  var monNameStr = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec";
  var monName=monNameStr.split(" ");
  var ck, c, dn;


  day = dayName[day];
  month = monName[month];

//  ck = 'time24'+glob.id;
//  c = getCookie(ck);
  dn = ""
  if ((c == undefined) || (parseInt(c) < 1)){
    dn="am"
    if (hours>11){ dn="pm" }
    if (hours>12){ hours=hours-12; }
    if (hours==0){ hours=12; }
  }

  if (minutes<=9)
  minutes="0"+minutes
  res = month+' '+date+' '+year+' '+hours+":"+minutes+" "+dn;
  return res;
}

function getCookie(name) {
  var dc = document.cookie;
  var prefix = name + "=";
  var begin = dc.indexOf("; " + prefix);
  if (begin == -1) {
    begin = dc.indexOf(prefix);
    if (begin != 0) return null;
  } else
    begin += 2;
  var end = document.cookie.indexOf(";", begin);
  if (end == -1)
    end = dc.length;
  return unescape(dc.substring(begin + prefix.length, end));
}


function xopenGame(id, role, side){
  if (parseInt(id) > 0){
//    open('/arimaa/games/showGame.cgi?gid='+id+'&s='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    open('/arimaa/gameroom/comments.cgi?gid='+id,'','');
  }
  else{
    if (parseInt(id) == 0){
      alert("Game was won by forfeit");
    }
    else{
      alert("To watch the game login to the Arimaa gameroom and use 'Current Games'");
    }
  }
  void('');
}

// -->
    </script>
EOM
}

$liveClock = <<EOM;

        <form name=clock onSubmit='return false'>
<div id=liveclock style="position:fixed;left:1;top:0;z-index:1;background-color:lightblue;width:100%">
  <table width=100% cellspacing=0 cellpadding=0>
    <tr>
      <td align=left valign=top>
          <span id='time' style='background-color:cyan'></span>
<!--
          <input type=text size=22 name="time" class=timeText>
-->
YLT = GMT + <input type=text size=3 id=tzo value='' onChange='setTimeZone();'>
<font size=2><br>YLT = Your Local Time</font>
      </td>
      <td align=center valign=middle>
<font size=3><a href='./'>Home</a> &nbsp; &nbsp; <a href='$eventVideos'>Videos</a> <!-- <a href='$eventCoverage'>Coverage</a> &nbsp; &nbsp; <a href='$eventVideos'>Videos</a> &nbsp; &nbsp; <a href='predict/'>Contest</a> --> </font>
      </td>
    </tr>
  </table>
</div>
        </form>

<script>
var AdjTime = 1000 * $now;
var ZoneTime =  (0 - 28800);

function adjustTime(){
  var d = new Date()

  if (AdjTime != 0){
    AdjTime = AdjTime - d.getTime();
  }
}

function setTimeZone(){
  var val;
  var d = new Date()
  var tzo = document.getElementById('tzo');
//  document.getElementById('tzo').value = ''+1;
  var ho;

  if (tzo.value == ''){
    ZoneTime = 0;
    val = 0 - d.getTimezoneOffset()/60;
  }
  else{
//alert(d.getTimezoneOffset()/60);
//alert(tzo.value);
//    ZoneTime = 1000*3600*(0 - (d.getTimezoneOffset()/60 - tzo.value -12));
//    ZoneTime = 1000*3600*(0 - (d.getTimezoneOffset()/60 - tzo.value -12));
    ZoneTime = 1000*3600*( d.getTimezoneOffset()/60 - (0-tzo.value));
//alert(ZoneTime);
    val = tzo.value;
  }
  tzo.value = val;
  showTimes();
}

function showLiveClock(){
  var Digital=new Date()
  Digital = new Date(Digital.getTime() + AdjTime + ZoneTime);
//  Digital = new Date(Digital.getTime() + AdjTime );
  var hours=Digital.getHours()
  var minutes=Digital.getMinutes()
  var seconds=Digital.getSeconds()
  var day=Digital.getDay()
  var month=Digital.getMonth()
  var date=Digital.getDate()
  var dayNameStr="Sun Mon Tue Wed Thr Fri Sat";
  var dayName=dayNameStr.split(" ");
  var monNameStr = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec";
  var monName=monNameStr.split(" ");

  day = dayName[day];
  month = monName[month];
  var dn="am"
  if (hours>=12){
    dn="pm"
    hours=hours-12
  }
  if (hours==0){
    hours=12
  }
  if (minutes<=9)
  minutes="0"+minutes
  if (seconds<=9)
  seconds="0"+seconds
  myclock=hours+":"+minutes+":"+seconds+" "+dn +"  "+day+"  "+month+" "+date
//  document.clock.time.value = myclock;
  document.getElementById('time').innerHTML = myclock;
  setTimeout("showLiveClock()",1000)
}

setTimeout("adjustTime()", 200);
setTimeout("setTimeZone()", 200);
setTimeout("showLiveClock()",250)

</script>

EOM


print <<EOM;
<html>
  <head><title>$eventName</title></head>
    <link rel="stylesheet" type="text/css" href="/arimaa/css/main.css">
  <body bgcolor=#d8d8f8>
$func
$liveClock
    <center>
<h2>$eventName</h2>
<p><font size=+2><b>$eventName</b></font>
<p>
    <table border=0>
      <tr>
$watchGames
      </tr>
    <table>
    </center>
  </body>
</html>

EOM


sub getRadio{
  my($fh, $l, $p1, $p2, $by, $pin, %radio);
  open($fh, "<gr/radio");
  while ($l = <$fh>){
    chomp $l;
    ($p1, $p2, $by) = ($l =~ m/^\[(\S+) +(\S+)\] +\[([^\]]+)/);
    if ($by eq ''){ next; }
    $pin = lc("$p1 $p2");
    $radio{$pin} = $by;
  }
  close $fh;
  return %radio;
}




